﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@
' =======================================================================================
' Description ...: Form Generator
' Requirement(s).: Basic4Android 9.00
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.10.0
' Date...........: 14 March 2022
' License........: Free to use without any warranties
' =======================================================================================
'Class module
Sub Class_Globals
	Dim Version As String = "Version 0.10.0 14 March 2022"
	Dim fh_Data As Map		' Reference to widget of data
	Private fh_FieldsType As Map = CreateMap()	' Reference to fields type
	Private numericTypes As Map = CreateMap("N":True,"NS":True,"NF":True,"S":True)	' widgets with numeric values
	Private comparator As Map = CreateMap("=":1,">":2,"<":4,">=":3,"<=":5,"<>":6)
	Private defLength As Map = CreateMap("S":200dip,"QS":200dip,"F":30,"NF":9,"NS":8,"N":7,"P":16,"R":14,"I":0,"DATE":12,"TIME":10, _
									"TB":6,"TITLE":"","C":40,"UN":8,"B":70dip,"IB":35dip)
	Dim normType As Map = CreateMap("HIDDEN":"H","IMAGE":"I","BACKGROUND":"GROUND","DEFAULTS":"DEFAULT", _
									"RDEFAULTS":"RDEFAULT","COMMENT":"C","TOGGLE":"TB","RDB":"R")
	Private colorsMap As Map = CreateMap("red":Colors.red,"green":Colors.green,"blue":Colors.blue, "magenta":Colors.Magenta, _
							"yellow":Colors.Yellow,"gray":Colors.Gray,"lightgray":Colors.LightGray,"cyan":Colors.Cyan, _
							"black":Colors.Black,"teal":Colors.RGB(0,127,127),"white":Colors.White, _
							"olive":Colors.RGB(127,127,0),"aqua":Colors.RGB(0,255,255),"orange":Colors.RGB(255,165,0), _
							"silver":Colors.RGB(192,192,192),"crimson":Colors.RGB(220,20,60), "purple":Colors.RGB(128,0,128))
	'	1 Text
	'		16384	Cap sentences
	'		128		password
	'		131072	multiline
	'	2 Number
	'		4096	signed
	'		8192	decimal
	'	4 Date
	'		16		date
	'		32		time
	Dim textAttributes As Map = CreateMap("DATE":Bit.Or(4,16),"NF":Bit.Or(2,Bit.Or(4096,8192)),"P":Bit.Or(1,128), _
										"NS":Bit.Or(2,4096),"N":2,"S":Bit.Or(2,4096),"TIME":Bit.Or(4,32))
	Dim fh_yesToExit As Boolean = True	' used for block exit
	Dim fhMap_ColorDrawable As Map = CreateMap()
	Dim fhSubstMap As Map = CreateMap()
	Dim timersMap As Map
	Private fh_module As Object	' calling Module
	Private fh_returnSub As String	' receiving sub
	Private fh_handleSub As String	' handle events sub
	Private fh_panel As Panel	' Reference to panel handle
	Private fh_panels(10) As Panel	' for TAB
	Dim fh_groundPanel As ScrollView
	Private nTabs As Int
	Dim customOkButton As Boolean ' true Ok button isn't generate
	Private currentTab As Int
	Private heightHeadTab As Int = 50dip
	Private dimLabel(10) As Int
	Type tabAttrib(lbl As Label, caption As String, ground As String, height As Int)
	Dim tabAttribs(10)	As tabAttrib
	Dim baseHeight As Int = 48/1dip
	Dim widgetRef As Map		' Reference to widget of data
	Private Elem As Map			' data fields
	Dim Defaults As Map			' fields defaults
	Private hiddensMap As Map	' hiddens fields
	Private ground As String	' contains ground
	Private tipsMap As Map		' tooltips Map, key is field name
	Private checks As Map		' checks on wiew, key is field name
	Private after As Map		' after key is view to set after value
	Dim nElem As Int			' Elements number
	Dim Limits As Map			' for numerics fields
	Private mapValues As Map	' combo/radio key value
	Dim togglesMap As Map
	Dim allButtons As Map		' buttons map
	Dim handleButtonsMap As Map	' handles
	Dim field() As String
	Private charPerRow As Int	' maximum widget width
	Private charHeight As Float	' height for 12 
	Private pnl As Panel
	Dim offsetButtons As Int	' for center buttons
	Dim btnWidth As Int = 70dip
	Private Matcher1 As Matcher
	Dim Sections(1,3) As String	' sections array
	Dim Section As Int			' section number
	Dim act As Activity
'	Dim VR As VoiceRecognition
'	VR.Initialize("VR")
	Private focusTxt As EditText
	Private typeForm As String	' typeForm: T = text, B = buttons, C = combo box (spinner)
	Private backgroundDrawable As ColorDrawable
	Public re As String = "^\s*([-+]?\d+)\s+([-+]?\d+)\s*$"	' for caputure n1 n2 (ex -100 100)
	Public labels(4) As Object	' eventual label (label,gravity,pixel dimension,color)
	Dim mapFontLabel As Map = setTipefaces("12 left ")
	Dim mapFontTitle As Map = setTipefaces("20 center ")
'   window size
	Private wTop, wLeft, wWidth, wHeight As Int	' pseudo window coordinates
	Private padding() As Int = Array As Int(4dip,5dip,2dip,0dip)	' for texts and spinners
	Private spinnerPadding() As Int = Array As Int(4dip,1dip,2dip,0dip)	' for texts and spinners
	Private border As String
	Public keyValueSeparator As String = ":"
'	Regular expressions
	Public reTime As String = "\s*|^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]:[0-5][0-9]$"
	Public reMail As String = "^[a-zA-Z0-9._+-]+@[a-zA-Z0-9-]+\.[a-zA-Z]{2,4}+$|^$"
'							   ^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+
	Public reCheckOperands As String = ".+\s*(=|<=|>=|<>|>|<|is)\s*(.*)"
	Public reHexaDecimal As String = "^[\daAbBcCdDeEfF]{1,8}$"
	Public reDeMask As String = "#\d+|#[xX][aAbBcCdDeEfF\d]+" 'one or more digits
	Dim fh_isRunning As Boolean
'	Dim fh_isLoaded As Boolean = False
'	tuning parameters 
	Dim borderLineWidth As Int = 1dip
	Dim shadowWidth As Int = 10dip
	Dim deltaY As Int = 40dip				' standard widget distance
	Private widgetHeight As Int = deltaY*0.75	' standard widget height
	Private canvForMeasure As Canvas
End Sub
Public Sub Initialize
End Sub
Sub fgw(activ As Activity,params As String,Module As Object,handleSub As String)	' for handle data in the same calling sub	
	fg(activ,params,Module,"",handleSub)
End Sub
Sub quoteMask(params As String) As String
	Dim pattern As String = $"[,:]?('(.*?)'|"(.*?)")[,;]"$		' //sm    [,;]('(.*?)'|"(.*?)")[,;]
	Dim ck As Int
	Do While True
		Dim m As Matcher = Regex.Matcher2(pattern, Regex.MULTILINE,params & ";")
		If m.Find Then
			ck = ck + 1
			For g = 2 To m.GroupCount
				If m.Group(g) <> Null Then
					fhSubstMap.Put("@" & ck,params.SubString2(m.getStart(g),m.getEnd(g)))
					params = params.SubString2(0,m.getStart(g)-1) & "@" & ck & params.SubString(m.getEnd(g)+1)
				End If
			Next
		Else
			Exit
		End If
	Loop
	Return params
End Sub
Sub fg(activ As Activity,params As String,Module As Object,retSub As String,handleSub As String)
	fh_isRunning = True
	fh_returnSub = retSub
	fh_handleSub = handleSub
	fh_module = Module
	labels = Array("",Gravity.LEFT,6dip,Colors.White)
	act = activ
	' ;'.*?;			change comments character
'	Dim txt As String = "'Window,,100;'covers the whole screen;'Ground,Blue Black;'Label,,Right, :;'T,Name,,15,El Condor,Patient Name;After,AgeType,Age;P,repeatPsw,Repeat Password,15,Portone,Retype password;Check,repeatPsw=psw,Password unmatched;Check,'psw is .{6,}',Password too short;Required,psw;"
	params = Regex.Replace2(";'|^'",Regex.MULTILINE,";"&params,";#")
	' ' and ""
	params = quoteMask(params)
	Dim prefix As String = ""
	Dim MatchSection As Matcher = Regex.Matcher2("(.*?);(Section,.*)",Regex.CASE_INSENSITIVE,params)
	Dim beforeSection As String = ""
	If MatchSection.Find Then
		beforeSection = MatchSection.Group(1) & ";"
		params = MatchSection.Group(2)
	End If	
	If Not(Regex.IsMatch2("^\s*section.*",Regex.CASE_INSENSITIVE,params)) Then prefix = "Section,;"
	Dim s() As String = Regex.split2(";*\s*section,",Regex.CASE_INSENSITIVE,prefix & params.Replace(Chr(10),""))
	Dim Sections(s.Length-1,3) As String	' section widgets, Section name, check condition(s)
	For i = 1 To s.Length -1
		Matcher1 = Regex.Matcher("(.*?);(.*)",s(i))
		If Matcher1.Find Then
			Dim sectorParm() As String = Regex.Split(",",Matcher1.Group(1))	' force three fields
			Sections(i-1,0) = beforeSection & Matcher1.Group(2)	' prefixed by possibly views commons to all sections
			' this above for possibly lack of title, i.e. title from section name
			If beforeSection <> "" Then
				If sectorParm(0) <> "" Then Sections(i-1,0) = beforeSection & ";Title,fh_section" & i & "," & sectorParm(0) & ";" & Matcher1.Group(2)
			End If
			Sections(i-1,1) = sectorParm(0)		' section name
			Sections(i-1,2) = implodeFrom(",",sectorParm,1,sectorParm.Length-1)	' check conditions
		End If
	Next
	Section = 0
	fgSection(Sections(0,Section),Null)
End Sub
Sub fgSection(params As String, data As Map)	' Map if section (data is fh_Data)
	If Not(data.IsInitialized) Then
		fh_Data.Initialize
		fh_FieldsType.Initialize
	End If
	widgetRef.Initialize
	Elem.Initialize
	tipsMap.Initialize
	checks.Initialize
	Limits.Initialize
	mapValues.Initialize
	Defaults.Initialize
	hiddensMap.Initialize
	togglesMap.initialize
	after.Initialize
	timersMap.initialize
	fh_groundPanel.Initialize(100%y)	' panel container
	fh_panel.Initialize("")
	nTabs = 0
	currentTab = 1
	dimLabel(0) = 0
	wLeft = 0
	wTop = 0
	wWidth = 100%x
	wHeight = 0
	border = ""
	Dim cmb As Spinner
	Dim rdb As RadioButton
	Dim widgets() As String
	Dim dummy,width,offsetX, offsetY As Int
	Dim wdgType As String
	allButtons.Initialize
	handleButtonsMap.Initialize
	customOkButton = False	' true Ok button isn't generate
	Dim fromTo() As String	' array for limits (used also for ground colors and defaults)
	offsetX = 2%x
	width = 50dip	' used fror slider (ll slider is 3 * width)
	widgets = Regex.Split(";\s*",params)
	Dim sSelector As Int = 28dip	' spinner selector right position
	canvForMeasure.Initialize(act)
	Dim charWidth As Float = canvForMeasure.MeasureStringWidth("EepgAaSsIimw09",Typeface.DEFAULT,12)/14
	Dim s As String = "Epqy"
	charHeight = 1dip * canvForMeasure.MeasureStringHeight(s,Typeface.DEFAULT,12)
	' normalize request: control and clean parameters
	ground = "FF404040 FF404040"	' default gradient
	Private title() As String	= Array As String("","","","")
' create triangle ----------------------------------------------------------------------------
	Private triangle As Bitmap = createTriangle(widgetHeight,widgetHeight)	' for spinners
' check parameters ---------------------------------------------------------------------------
	For iw = 0 To widgets.Length - 1
		If Left(widgets(iw),1) = "#" Or widgets(iw) = "" Then Continue	' comment
		field = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""		' remove *
		field(0) = normType.GetDefault(field(0).ToUpperCase,field(0).ToUpperCase)	' upper case and synonim
		Select field(0)
			Case "DEFAULT", "RDEFAULT"				' defaults view
				For ir=1 To field.Length - 1
					If field(ir) <> "" Then
						fromTo = Regex.split("\s*" & keyValueSeparator,field(ir) & keyValueSeparator)
						If field(0) = "RDEFAULT" Then fromTo = extractRandom(fromTo)
						If fromTo.Length = 2 Then Defaults.Put(fromTo(0),deMask(fromTo(1)))
					End If
				Next			
			Case "REQUIRED"					' required view
				For ir=1 To field.Length - 1
					addCheck(field(ir) & " is required","required")
				Next
			Case "H"						' Hiddens fields
				hiddensMap.put(field(1),field(2))
				fh_FieldsType.Put(field(1),field(0))
				widgetRef.Put(field(1),Array As Object(0,"H",0,0,nTabs))
			Case "CHECK"					' checks on fields
				addCheck(deMask(field(1)),deMask(field(2)))
			Case "AFTER"					' after
				If Not(fh_FieldsType.ContainsKey(field(1))) Then
					MsgboxAsync("View " & field(1) & " not exists!","After ignored")
				Else
					If Not(fh_FieldsType.ContainsKey(field(2))) Then
						MsgboxAsync("View " & field(2) & " not exists!","After ignored")
					Else
						after.Put(field(1),field(2))
					End If
				End If
			Case "GROUND"				' Background
				If nTabs = 0 Then 
					ground = field(1)	' global ground
				Else
					tabAttribs(nTabs).ground = field(1)
				End If
			Case "LABEL"
				labels(0) = field(3)	' text after label
'				If field(2).ToUpperCase = "RIGHT" Then labels(1) = Gravity.RIGHT
				labels(2) = canvForMeasure.MeasureStringWidth(labels(0),Typeface.DEFAULT,12) + 6dip
				mapFontLabel = setTipefaces("left " & field(2))
'				labels(3) = mapFontLabel.get("TextColor")	' label text color
			Case "WINDOW"
				If IsNumber(field(1)) Then wWidth = 100%x * field(1) / 100 
				If field(2) = "" Then
					wHeight = 0
				Else
					wHeight = 100%y * field(2) / 100
				End If
				If IsNumber(field(3)) Then wLeft = 100%x * field(3) / 100
				If IsNumber(field(4)) Then wTop = 100%y * field(4) / 100
				If wWidth <> 100%x And field(3) = "" Then wLeft = 0.5 * (100%x - wWidth)
				If wHeight > 0 And field(4) = "" Then 
					wTop = 0.5 * (100%y - wHeight)
				Else
					If field(4) = "" Then wTop = -1	' is set when wHeight is known for center
				End If
				border = field(5).ToLowerCase
				If field(6) <> "" Then ground = field(6)	' global ground
			Case Else
				If field(1) = "" Then field(1) = "fhw_" & Elem.Size	' if name lacks
				If field(0) = "TAB" Then
					nTabs = nTabs +1
					If field(1) = "" Then field(1) = "fh_tab" & nTabs	' if name lacks
					field(2) = deMask(field(2))
					dimLabel(nTabs) = 0
					tabAttribs(nTabs).lbl = Createlabel(field(2),14,"onglets")
					tabAttribs(nTabs).caption = field(2)
					tabAttribs(nTabs).height = 0
					tabAttribs(nTabs).ground = ground
					tabAttribs(nTabs).lbl.Tag = nTabs
				else If field(0) = "TITLE" Then		' title
					title = Array As String(field(1), deMask(field(2)), field(3), field(4))	'  save for possible tab
					Dim mapFontTitle  As Map = setTipefaces("20 center " & field(4))
				Else If field(0) = "TIME" Then
					addCheck(field(1) & " is " & reTime,"Incorrect time")
				Else If field(0) = "TIMER" Then
					If Not(IsNumber(field(3))) Then field(3) = 1000
				Else If field(0) = "TB" Then	' Toggle button
					If field(5) = "" Then field(5) = "On|Off"
				End If
				If field(2) = "" Then field(2) = field(1)	' if there is not label
				If field(0) = "" Then field(0) = "T"
				If field(0) = "C" And field(4) = "" Then field(4) = field(2)	' comment in label if not in default
				field(2) = deMask(field(2))
				field(4) = deMask(field(4).Trim())
				field(5) = deMask(field(5))
				If Not(IsNumber(field(3))) Then 
					field(3) = defLength.GetDefault(field(0),Max(20,field(4).Length))
				Else
					If "B*S*QS*".Contains(field(0) & "*") Then field(3) = field(3) * 160dip / 160
				End If
				If Not(Defaults.ContainsKey(field(1))) Then 
					Defaults.Put(field(1),field(4))	' set defaults map
				End If
				If field(0) = "S" Then
					If field(5) = "" Then field(5) = "0 100"	' default slide
					fromTo = Regex.split(" ",field(5))
					Limits.Put(field(1) & "Min",fromTo(0))
					Limits.Put(field(1) & "Max", 100)
					If fromTo.Length = 2 Then Limits.Put(field(1) & "Max",fromTo(1))
					Limits.Put(field(1) & "Delta", Limits.get(field(1) & "Max") - Limits.get(field(1) & "Min"))
				End If
				If Not("B*C*TAB*TITLE*I*TB*".Contains(field(0) & "*")) Then	' label dimension
					dummy = 3dip + canvForMeasure.MeasureStringWidth(field(2),Typeface.DEFAULT,12)
					If dummy > dimLabel(nTabs) Then dimLabel(nTabs) = dummy					
				End If
				Elem.Put(field(1),field)
				fh_FieldsType.Put(field(1),field(0))	' for all type
			End Select
	Next
	Dim panelHeight As Int = 0
	If nTabs > 0 Then
		Dim labelTabsWidth As Int = (wWidth-10)/nTabs	' for possible shadow
	End If
	If dimLabel(nTabs) > 50%x Then dimLabel(1) = 50%x
	nElem = Elem.Size
	typeForm = ""				' for type of final buttons
	' create form -------------------------------------------------------------------------------------
	offsetY = IIf(title(0) = "", 5dip,deltaY+5dip)
	Dim tabsTop As Int = offsetY	' tabs labels
'	fh_groundPanel.Initialize(100%y)	' panel container
'	fh_panel.Initialize("")
	nTabs = 0
	For ck = 0 To nElem - 1
		Dim widgetPosition As Int = offsetX + dimLabel(nTabs) + labels(2)
		charPerRow = Ceil((wWidth - 2*offsetX - widgetPosition - IIf(nTabs > 0,20dip,0)) / charWidth)
		field = Elem.GetValueAt(ck)
		wdgType = field(0)
		If wdgType = "TITLE" Then Continue		' title			
		If wdgType = "TIMER" Then				' timer
			Dim t As Timer
			t.Initialize("fh_timer",field(3))
			widgetRef.Put(field(1),Array As Object(t,wdgType,0,field(5),nTabs))
			timersMap.put(t,field(1))
			Continue
		else If wdgType = "TAB" Then
			If nTabs > 0 Then
				If offsetY > panelHeight Then panelHeight = offsetY
				tabAttribs(nTabs).height = offsetY
			End If
			offsetY = IIf(title(0) = "", 5dip,deltaY) + heightHeadTab
			nTabs = nTabs + 1
			fh_panels(nTabs).Initialize(100%y)
			fh_panel = fh_panels(nTabs)	' *** *** 14/11/19
			Continue
		End If
		Dim textHeight As Int = getHeight(Ceil(field(3)/charPerRow))	' height for view
		Dim itemHeight As Int = widgetHeight	' height for view
		Dim lbl As Label = Createlabel(field(2) & labels(0),mapFontLabel.Get("TextSize"),"")		' possible extra characters
		lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, mapFontLabel.Get("Gravity"))
		lbl.TextColor = mapFontLabel.Get("TextColor")	' it is also in mapFontLabel.Get("TextColor")
		lbl.Typeface = mapFontLabel.Get("Typeface")
		lbl.Tag = field(1)	' fieldName
		Dim txtProto As EditText
		If wdgType = "B" Then
			If field(4) <> "" Then Defaults.Put(field(1),field(4))
			If after.ContainsKey(field(1)) Then
				Dim btn As Button = genAfterButton(field)
				handleButtonsMap.put(field(1),btn)
				widgetRef.Put(field(1),Array As Object (btn,wdgType,0,field(5),nTabs))
			Else
				If Not("CancelReset".Contains(field(1))) And field(5) = "" Then customOkButton = True
			End If
			allButtons.Put(field(1),Array As String (field(2) , field(5),nTabs))
			Continue
		Else If wdgType = "IB" Then		' in line button
			Dim mapFontIB As Map = setTipefaces("left " & field(6))
			Dim inLineBtn As Button = fg_CreateButton(field(1),field(2),12,"Buttons")
			widgetRef.Put(field(1),Array As Object (inLineBtn,wdgType,0,0,nTabs))
			fh_panel.AddView(inLineBtn,offsetX, offsetY, field(3), widgetHeight)
			Dim lblIB As Label = Createlabel(field(4),mapFontIB.Get("TextSize"),"")
			lblIB.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, mapFontLabel.Get("Gravity"))
			lblIB.TextColor = mapFontLabel.Get("TextColor")	' it is also in mapFontLabel.Get("TextColor")
			lblIB.Typeface = mapFontLabel.Get("Typeface")
			lblIB.Tag = field(1)	' fieldName
			fh_panel.AddView(lblIB,offsetX+inLineBtn.width, offsetY, 30*charWidth, widgetHeight)
			allButtons.Put(field(1),Array As String (field(2) , field(5),nTabs))
			after.Put(field(1),"")	' prevents insert in bottom
		Else If wdgType = "TB" Then
			togglesMap.put(field(1),splitKeyValue(field(1),field(5)))
			Dim btnToggle As Button = fg_CreateButton(field(1),"",12,"tButtons")
			widgetRef.Put(field(1),Array As Object (btnToggle,wdgType,lbl,0,nTabs))
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
				fh_panel.AddView(btnToggle,afterView.Left+afterView.Width+10dip, afterView.Top, field(3) * charWidth,  widgetHeight)
				topAfterView(afterView,btnToggle)
			Else
				fh_panel.AddView(btnToggle,widgetPosition, offsetY, field(3) * charWidth, widgetHeight)
			End If
		Else If wdgType = "CKL" Then
			Dim ckList As List = splitKeyValue(field(1),field(5))
			For j = 0 To ckList.Size-1
				Dim ckbProto As CheckBox
				ckbProto.Initialize("checkBox")
				ckbProto.TextSize = 12
				ckbProto.text = " " & ckList.get(j)
				ckbProto.TextColor = mapFontLabel.Get("TextColor")
				Dim name As String = mapValues.get(field(1) & ckList.get(j))
				ckbProto.Tag = name
				fh_panel.AddView(ckbProto,widgetPosition, offsetY+(deltaY-5dip)*j, field(3) * charWidth, widgetHeight)
				widgetRef.Put(name,Array As Object (ckbProto,wdgType,lbl,field(1),nTabs))
				If Not(Defaults.ContainsKey(name)) Then Defaults.Put(name,"")	' set defaults map
				fh_FieldsType.Put(name,"CKL")
			Next
			CreateText(txtProto,field)
			fh_panel.AddView(txtProto,0, 0, 0, 0)	' an invisible text
			widgetRef.Put(field(1),Array As Object (txtProto,"T",lbl,"",nTabs))
			Defaults.Put(field(1),0)				' this is the check list counter
			fh_FieldsType.Put(field(1),"T")
			itemHeight = ckList.Size * (deltaY-5dip)
		Else If wdgType = "CKB" Then
			Dim ckbProto As CheckBox
			ckbProto.Initialize("checkBox")
			ckbProto.TextSize = 12
			ckbProto.text = " " & field(5)
			ckbProto.Tag = field(1)
			ckbProto.TextColor = mapFontLabel.Get("TextColor")
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				If field(5) = "" Then ckbProto.text = " " & field(2)	' label instead 29 4 2019
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
				fh_panel.AddView(ckbProto,afterView.Left+afterView.Width+10dip, afterView.Top, field(3) * charWidth, deltaY-4dip)
				topAfterView(afterView,ckbProto)
			Else
				fh_panel.AddView(ckbProto,widgetPosition, offsetY, field(3) * charWidth, widgetHeight)
			End If
			widgetRef.Put(field(1),Array As Object (ckbProto,wdgType,lbl,0,nTabs))
		Else If wdgType = "R" Then			' *** Radiobuttons
			Dim rdbList As List
'			dim j As Int
			rdbList = splitKeyValue(field(1),field(5))
			pnl.Initialize("")
			widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,Null,nTabs))
			For j = 0 To rdbList.Size-1
				rdb.Initialize("RadioButton")
				rdb.TextSize = 12
				rdb.text = rdbList.get(j)
				rdb.Tag = field(1)
				pnl.AddView(rdb,j*field(3) * charWidth,0dip,field(3) * charWidth, getHeight(1))
				If rdbList.get(j) = field(4) Then widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,rdb,nTabs))	' default
				If File.Exists(File.DirAssets,rdb.text) Then ' grafic button
					Dim gBtn As Button = fg_createButtonImage(rdb.text,"RDBbuttons")
					Dim wh() As String = Regex.Split("x",gBtn.Tag)
					gBtn.Tag = rdb			
					pnl.AddView(gBtn, 37dip + j*field(3) * charWidth,5dip,wh(0)+10dip, wh(1)+10dip)
					rdb.width = 28dip
				End If
			Next
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
				fh_panel.AddView(pnl,afterView.Left+afterView.Width+10dip, afterView.Top, field(3) * charWidth, afterView.height)
				topAfterView(afterView,pnl)
			Else
				fh_panel.AddView(pnl,widgetPosition, offsetY, field(3) * charWidth, widgetHeight)
			End If
			pnl.width = 90%x
		Else If "*CMB*CMX*CMT*F*".Contains("*" & wdgType & "*") Then		' *** ComboBox (spinner) and File
			cmb.Initialize("combos") 'All combos share the same event sub
			cmb.TextSize = 12
			cmb.Padding = spinnerPadding
			backgroundDrawable.Initialize(Colors.ARGB(63,255,255,255), 3dip)
			fhMap_ColorDrawable.Put(field(1),backgroundDrawable)
			cmb.Background = fhMap_ColorDrawable.get(field(1))
			Dim yText As Int = offsetY
			Dim ySpinner As Int = offsetY
			If wdgType = "CMT" Then 
				ySpinner = offsetY+textHeight + 2dip
				itemHeight = itemHeight + textHeight
			End If
			If wdgType = "CMX" Then 
				itemHeight = itemHeight + textHeight
				yText = offsetY+getHeight(1) + 1dip
			End If
			Dim cmbWidth As Int = Min(field(3),charPerRow) * charWidth
			fh_panel.AddView(cmb,widgetPosition, ySpinner, cmbWidth, widgetHeight)
			Dim labTdown As Label = Createlabel("",12,"")
			labTdown.SetBackgroundImage(triangle)
			fh_panel.AddView(labTdown,cmb.Left+cmb.Width-sSelector, cmb.top, sSelector, cmb.height)
			cmb.Tag = field(1)
			If wdgType <> "F" Then
				cmb.addall(splitKeyValue(field(1),field(5)))
				cmb.Prompt = field(2)	' the label is prompt
			Else
				Dim lblFile As Label = Createlabel("",8,"")
				Dim lblFileLeft As Int = cmb.Left+cmb.width + 1dip
				fh_panel.AddView(lblFile,lblFileLeft, cmb.top, 100%x-lblFileLeft-10dip, cmb.height)
				tipsMap.Put(field(1),lblFile)
			End If
			widgetRef.Put(field(1),Array As Object (cmb,wdgType,lbl,"",nTabs))
			If wdgType = "CMT" Or wdgType = "CMX" Then		' combo + text added
				CreateText(txtProto,field)
				widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,cmb,nTabs))
				fh_panel.AddView(txtProto,widgetPosition , yText, IIf(field(3) > charPerRow, charPerRow,field(3)) * charWidth, getHeight(Ceil(field(3)/charPerRow)))
			End If
		Else If wdgType = "U" Or wdgType = "UN" Then
			Dim uLbl As Label = Createlabel(field(4),12,"")
			If wdgType = "UN" Then uLbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.RIGHT)
			Dim labelWidth As Int = IIf(field(3) > charPerRow, charPerRow,field(3)) * charWidth
			widgetRef.Put(field(1),Array As Object (uLbl,wdgType,lbl,uLbl,nTabs))
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
				fh_panel.AddView(lbl,afterView.Left+afterView.Width, afterView.Top, (field(2) & labels(0)).Length * charWidth, widgetHeight)
				fh_panel.AddView(uLbl,lbl.Left+lbl.Width, afterView.top,labelWidth, widgetHeight)
				topAfterView(afterView,lbl)
			Else
				fh_panel.AddView(uLbl,widgetPosition, offsetY, labelWidth, getHeight(Ceil(field(3)/charPerRow)))
			End If
		Else If wdgType = "C" Then	' comment
			Dim cText As EditText
			Dim mapFontComment As Map = setTipefaces("12 left " & field(5))
			cText.initialize("")
			cText.TextSize = mapFontComment.Get("TextSize")
			cText.Color = Colors.Transparent
			cText.TextColor = mapFontComment.Get("TextColor")
			cText.Enabled = False
			cText.Text = field(4)
			cText.Gravity = Bit.Or(Gravity.CENTER_VERTICAL,mapFontComment.Get("Gravity"))
'			If field(5).ToLowerCase = "center" Then cText.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
'			If field(5).ToLowerCase = "right" Then cText.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.RIGHT)
			fh_panel.AddView(cText,offsetX, offsetY,wWidth-2*offsetX,-2)
			Dim su As StringUtils
			itemHeight = Max(su.MeasureMultilineTextHeight(cText,cText.Text),widgetHeight)
			widgetRef.Put(field(1),Array As Object (cText,wdgType,0,0,nTabs))
		Else If wdgType = "I" Then	' Image
			Dim x As Int = 0
			Dim img As ImageView = createImage(fh_panel,field(2),IIf(field(3) = "",0,field(3)),IIf(field(4) = "",-1,field(4)),offsetY)
			widgetRef.Put(field(1),Array As Object (img,wdgType,0,0,nTabs))
			borders(img,field(5),False)	' possible border/shadow
			itemHeight = img.Height + 0.1*deltaY
		Else
			itemHeight = textHeight
			CreateText(txtProto,field)
			If "*NF*NS*N".Contains("*" & field(0)) Then txtProto.Gravity = Gravity.Right	' numerics fields
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,txtProto,nTabs))
			If wdgType = "S" Or wdgType = "QS" Then		' *** slide ***
				Dim seekBar As SeekBar
				Dim seekLabel As Label = Createlabel(field(3),12,"")
				seekBar.Initialize("Slide")
				seekBar.Tag = field(1)	' widget name
				widgetRef.Put(field(1),Array As Object (seekBar,wdgType,lbl,seekLabel,nTabs))
				If wdgType = "QS" Then	' *** qualitative slide ***
					Private listSQ As List = splitKeyValue(field(1),field(5))
					Limits.Put(field(1),listSQ)
					seekBar.Max = listSQ.Size - 1
				End If
				fh_panel.AddView(seekBar,widgetPosition, offsetY, field(3), deltaY*0.85)
				fh_panel.AddView(seekLabel,seekBar.Left+seekBar.Width, offsetY, 10 * charWidth, getHeight(1))
				itemHeight = getHeight(1)
			Else	' this is a text field I suppose
				txtProto.HintColor = Colors.LightGray
				txtProto.Hint = field(5)
				If field(6) <> "" Then tipsMap.Put(field(1),deMask(field(6)))			
				If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
					Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
					fh_panel.AddView(lbl,afterView.Left+afterView.Width+10dip, afterView.Top, 6dip+(field(2) & labels(0)).Length * charWidth, deltaY-4dip)
					fh_panel.AddView(txtProto,lbl.Left+lbl.Width,afterView.Top, IIf(field(3) > charPerRow, charPerRow,field(3)) * charWidth, textHeight)
					topAfterView(afterView,txtProto)
				Else
					fh_panel.AddView(txtProto,widgetPosition, offsetY, IIf(field(3) > charPerRow, charPerRow,field(3)) * charWidth, textHeight)
				End If			
			End If
		End If
		If wdgType = "CMB" Then 
			typeForm = typeForm & "C"
		Else
			If Not("*I*C*IB".Contains("*" & field(0))) Then
				typeForm = typeForm & wdgType
			End If
		End If
		If Not(after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1)))) Then
			If Not("*I*C*IB".Contains("*" & field(0))) Then
				fh_panel.AddView(lbl,offsetX, offsetY, dimLabel(nTabs)+labels(2), widgetHeight)
				lbl.Top = offsetY+(itemHeight - lbl.Height)*0.5
				lbl.Invalidate
			End If
			offsetY = offsetY + itemHeight + 10dip
		End If
	Next
	If nTabs > 0 Then 
		tabAttribs(nTabs).height = offsetY	' last tabs height
		If offsetY > panelHeight Then panelHeight = offsetY	' last tabs height
		panelHeight = panelHeight + heightHeadTab
	Else 
		panelHeight = offsetY
	End If
	' what buttons?
	If typeForm <> "C" And nTabs = 0 Then ' if no only one spinner
		Dim pnlButtons As Panel = createPanelButtons(0)
		fh_panel.AddView(pnlButtons,offsetButtons,panelHeight,pnlButtons.width,deltaY)
		panelHeight = panelHeight + deltaY
	End If
	If border <> "" Then panelHeight = panelHeight + shadowWidth
	If wHeight = 0 Then wHeight = panelHeight
	If title(0) <> "" Then
'		Dim lblTitle As Label = createTitle(title)
		Dim lblTitle As Label = Createlabel(title(1),mapFontTitle.Get("TextSize"),"")
		lblTitle.Typeface = Typeface.DEFAULT_BOLD
		lblTitle.Typeface = mapFontTitle.Get("Typeface")
		lblTitle.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, mapFontTitle.Get("Gravity"))
		If title(2) <> "" Then	lblTitle.Color = decodeColor(title(2))
		lblTitle.TextColor = mapFontTitle.Get("TextColor")
		widgetRef.Put(title(0),Array As Object (lblTitle,"TITLE",0,0,nTabs))
		lblTitle.Tag = title(0)		
	End If
	If nTabs > 0 Then
		pnl.Initialize("")	' container for tabs labels
		For jk = 1 To nTabs
			Dim pnlButtons As Panel = createPanelButtons(jk)
			fh_panels(jk).Background = createGradient(tabAttribs(jk).ground)
			If jk > 1 Then fh_panels(jk).Visible = False
			fh_panels(jk).AddView(pnlButtons,offsetButtons,tabAttribs(jk).height,pnlButtons.width,deltaY)
			tabAttribs(jk).lbl.Text = CreateCSLabel(tabAttribs(jk).caption,IIf(jk = 1,True,False))
			pnl.Color =Colors.Gray
			pnl.AddView(tabAttribs(jk).lbl,labelTabsWidth*(jk-1),0,labelTabsWidth,deltaY)
			fh_panels(jk).Height = panelHeight
			fh_panels(jk).width = wWidth
			Dim x As Int = borders(fh_panels(jk),border,IIf(title(0) <> "",True,False))
			fh_groundPanel.Panel.AddView(fh_panels(jk),0,0,wWidth,panelHeight)
		Next
		If title(0) <> "" Then 
			lblTitle.BringToFront
			fh_groundPanel.Panel.AddView(lblTitle,0, 0, wWidth-10, deltaY)	' title is in ground panel and possible shadow
		End If
		fh_groundPanel.Panel.AddView(pnl,3dip,tabsTop,wWidth-IIf(x>0,IIf(x=1,6dip,16dip),6dip),deltaY)
		Dim buttonPosition As Int = wWidth-2.2*btnWidth
		If allButtons.ContainsKey("Ok") Then
			Dim k() As String = allButtons.Get("Ok")
			fh_groundPanel.Panel.AddView(fg_CreateButton("Ok",k(0),12,"buttons"), buttonPosition,panelHeight+2dip,btnWidth, deltaY-8dip)
		End If
		k = allButtons.Get("Cancel")
		fh_groundPanel.Panel.AddView(fg_CreateButton("Cancel",k(0),12,"buttons"), buttonPosition+btnWidth,panelHeight+2dip,btnWidth, deltaY-8dip)
		panelHeight = panelHeight+deltaY	' for buttons
	Else
		Dim isBorder As Int = IIf(border.StartsWith("border"),2*borderLineWidth,0)
		fh_panel.Background = createGradient(ground)
		If title(0) <> "" Then fh_panel.AddView(lblTitle,isBorder, isBorder, wWidth-2*isBorder, deltaY-2*isBorder)	' title is in form panel
		fh_panel.width = wWidth			' needs set for border
		fh_panel.height = panelHeight	' needs set for border
		borders(fh_panel,border,IIf(title(0) <> "",True,False))
	End If
	If nTabs > 0 Then wHeight = wHeight + deltaY
	If wTop = -1 Then wTop = Max(0,0.5 * (100%y - wHeight))
	If panelHeight > wHeight Or panelHeight > 100%y Then
		If nTabs = 0 Then
			fh_groundPanel.Panel.AddView(fh_panel,0,0,wWidth,panelHeight)
			fh_groundPanel.panel.Height = panelHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,wHeight)
		Else
			fh_groundPanel.panel.Height = panelHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,100%y-wTop)
		End If
	Else
		If nTabs > 0 Then 
			fh_groundPanel.panel.Height = wHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,wHeight)
		Else
			act.AddView(fh_panel,wLeft,wTop,wWidth,wHeight)
		End If
	End If
	handleEvents(Array As Object ("fh_start","Start","",title(0),Section))
	setDefaults(-1)	' for section
	If nTabs > 0 Then handleEvents(Array As Object ("TAB0","OPEN",""))
'	fh_isLoaded = True
End Sub
Sub genAfterButton(f() As String) As Button
	If File.Exists(File.DirAssets,f(2)) Then ' grafic button
		Dim afterBtn As Button = fg_createButtonImage(f(2),"buttons")
		Dim wh() As String = Regex.Split("x",afterBtn.Tag)
		afterBtn.Tag = f(1)
		wh(0) = wh(0)+20dip
		wh(1) = wh(1)+13dip
	Else
		Dim afterBtn As Button = fg_CreateButton(f(1),f(2),12,"buttons")
		Dim wh(2) As String = Array As String(f(3),deltaY-8dip)
	End If
	Dim afterView As View
	If fh_FieldsType.Get(after.Get(f(1))) = "B" Then
		afterView = handleButtonsMap.Get(after.Get(f(1)))
	Else
		afterView = getFromViewMap(after.Get(f(1)),0)
	End If
	Dim panelAfterView As Panel = afterView.parent
	panelAfterView.AddView(afterBtn,afterView.Left+afterView.Width+7dip, afterView.Top, wh(0), wh(1))
	topAfterView(afterView,afterBtn)
	Return afterBtn
End Sub
Private Sub fg_CreateButton(Name As String, caption As String,fSize As Int, event As String) As Button
	Dim btnX As Button
	btnX.Initialize(event)
	If File.Exists(File.DirAssets,caption) Then ' grafic button
		Dim x As Bitmap
		x.Initialize(File.DirAssets,caption)
		btnX.Tag = x.Width & "x" & x.height
	Else
		Dim f() As String = Elem.Getdefault(Name,Array As String("","","","","","",""))
		btnX.Padding = Array As Int (0, 0, 0, 0)
		Dim m As Map = setTipefaces(f(6))	' my be font awesome
		btnX.TextColor = m.Get("TextColor")
		btnX.TextSize = m.Get("TextSize")
		btnX.Typeface = m.Get("Typeface")
		btnX.Text = caption
		btnX.Tag = Name
	End If
	CreateRoundedButton(btnX)
	If File.Exists(File.DirAssets,caption) Then btnX.SetBackgroundImage(x)' grafic button
	handleButtonsMap.put(Name,btnX)
	Return btnX
End Sub
Sub setTipefaces( parms As String) As Map
	Dim m As Map = CreateMap("TextSize":12,"Typeface":Typeface.DEFAULT,"TextColor":Colors.White)
	If parms <> "" Then
		Dim s() As String = Regex.Split("\s+",parms)
		For i = 0 To s.Length - 1
			Select s(i).ToLowerCase
				Case "fa", "fontawesome"
					m.Put("Typeface", Typeface.FONTAWESOME)
				Case "mi", "materialicons"
					m.Put("Typeface", Typeface.MATERIALICONS)
				Case "left"
					m.Put("Gravity", Gravity.LEFT)
				Case "right"
					m.Put("Gravity", Gravity.RIGHT)
				Case "center"
					m.Put("Gravity", Gravity.CENTER_HORIZONTAL)
				Case Else
					If IsNumber(s(i)) Then
						m.Put("TextSize",s(i))
					Else
						m.Put("TextColor",decodeColor(s(i)))
					End If
			End Select		
		Next
	End If
	Return m
End Sub
Sub CreateRoundedButton(btnx As Button) As Button
	Dim cdwBtnEnabled As ColorDrawable	' Define a color for Enabled state
	cdwBtnEnabled.Initialize2(Colors.Gray,10,1dip,Colors.ARGB(127,15,15,15))
	Dim cdwBtnPressed As ColorDrawable	' Define a color for Pressed state
	cdwBtnPressed.Initialize2(Colors.LightGray,10,1dip,Colors.ARGB(127,15,15,15))
	Dim btnStateList As StateListDrawable	' Define a StateListDrawable
	btnStateList.Initialize
	Dim states(2) As Int
	states(0) = btnStateList.state_enabled
	states(1) = -btnStateList.state_pressed
	btnStateList.addState2(states, cdwBtnEnabled)
	Dim states(1) As Int
	states(0) = btnStateList.state_pressed
	btnStateList.addState2(states, cdwBtnPressed)
	btnx.Background = btnStateList	' Set btnStateList to button background
	Return btnx
End Sub
Sub fh_Timer_Tick
	Dim t As Timer = Sender
	handleEvents(Array As Object (timersMap.get(t),"TICK",Sender,""))
	fh_CallSub(timersMap.get(t),getFromViewMap(timersMap.get(t),3))
End Sub
Sub fh_CallSub(Name As String,cBack As String)
	Dim	fh_CallBackSub() As String = Regex.Split("\.",cBack)		' split module and sub
	If fh_CallBackSub.Length = 2 Then
		CallSubDelayed2(fh_CallBackSub(0),fh_CallBackSub(1),Name)
	Else
		CallSubDelayed2(fh_module,fh_CallBackSub(0),Name)
	End If
End Sub
Sub createPanelButtons(tabNumber As Int) As Panel
	Dim pnlButtons As Panel		' panel for buttons
	pnlButtons.Initialize("")
	If Section > 0 Then 
		allButtons.Put("fh_Back",Array As String("<--","",0))
	End If
	If Not(allButtons.ContainsKey("Cancel")) Then allButtons.put("Cancel",Array As String("Cancel","",0))
	If Not(Regex.IsMatch("U+",typeForm) Or typeForm = "") Then
		If Not(allButtons.ContainsKey("Reset")) Then allButtons.put("Reset",Array As String("Reset","",tabNumber))
		If Not(customOkButton) Then 
			allButtons.put("Ok",Array As String("Ok","",0))
		End If
	End If
	If Sections.Length > 1  Then
		If Section < Sections.Length -1 Then
			allButtons.put("fh_Forward",Array As String("-->","",0))
		End If
		If Section <> Sections.Length - 1 Then allButtons.Remove("Ok")
	End If
	Dim buttonTotalWidth As Int = 0	' total button width
	For i = 0 To allButtons.Size - 1
		Dim Name As String = allButtons.GetKeyAt(i)
		Dim k() As String = allButtons.GetValueAt(i)
		If after.ContainsKey(Name) Then Continue
		If Name <> "Reset" And k(2) <> tabNumber Then Continue	' k(2) contains tabposition
		If File.Exists(File.DirAssets,k(0)) Then ' grafic button
			Dim gBtn As Button = fg_CreateButton(Name,k(0),0,"buttons")
			Dim wh() As String = Regex.Split("x",gBtn.Tag)
			pnlButtons.AddView(gBtn,buttonTotalWidth,5dip, wh(0)+10,wh(1)+10)
			gBtn.Tag = Name
			handleButtonsMap.put(Name,gBtn)
			buttonTotalWidth = buttonTotalWidth + wh(0)+20dip
		Else
			pnlButtons.AddView(fg_CreateButton(Name,k(0),12,"buttons"), buttonTotalWidth,0,btnWidth, deltaY-8dip)
			buttonTotalWidth = buttonTotalWidth + btnWidth
		End If
	Next
	offsetButtons = (wWidth - buttonTotalWidth) * 0.5
	pnlButtons.Width = buttonTotalWidth
	Return pnlButtons
End Sub
Sub fg_createButtonImage(imgFile As String,eventHandler As String) As Button
	Dim gBtn As Button
	gBtn.Initialize(eventHandler)
	gBtn.Padding = Array As Int (10dip, 10dip, 10dip, 5dip)
	Dim x As Bitmap
	x.Initialize(File.DirAssets,imgFile)
	gBtn.SetBackgroundImage(x)
	gBtn.Tag = x.Width & "x" & x.height
	Return gBtn
End Sub
Sub createImage(destination As Panel, imgFile As String,w As Int, Lft As Int,Top As Int) As ImageView
	Dim fileInfo As Map = pathinfo(imgFile)
	If fileInfo.Get("dirname") = "" Then fileInfo.Put("dirname",File.DirAssets)
	Private img As ImageView
	img.Initialize("")
	Private bmp As Bitmap
	If File.Exists(fileInfo.Get("dirname"),fileInfo.Get("basename")) Then
		bmp.Initialize(fileInfo.Get("dirname"),fileInfo.Get("basename"))
	Else
		bmp.InitializeMutable(100dip,100dip)
		Dim cnv As Canvas
		cnv.Initialize2(bmp)
		cnv.DrawColor(Colors.Red)
	End If
	Dim wImg As Int = IIf(w>0,w,bmp.width)
	img.Bitmap = bmp.Resize(wImg,wImg/bmp.width*bmp.Height,True)
	If Lft = -1 Then Lft = (wWidth - wImg)/2
	destination.AddView(img,Lft,Top, wImg,wImg/bmp.width*bmp.Height)
	Return img
End Sub
Private Sub borders(panel As View,bound As String,title As Boolean) As Int	' returns 0 no border/shadow, 1 border, 2 shadow
	If bound = "" Then Return 0
	Dim canv As Canvas
	canv.Initialize(panel)
	Dim x() As String = Regex.Split("\s+",bound)
	Dim rect As Rect
	Select x(0)
		Case "border"
			rect.Initialize(borderLineWidth,borderLineWidth,panel.Width-borderLineWidth,panel.Height-borderLineWidth)
			Dim colorLine As Int = Colors.ARGB(127,0,0,0)
			If x.Length = 2 Then colorLine = decodeColor(x(1))
			canv.DrawRect(rect,colorLine,False,2*borderLineWidth)
			If title Then canv.DrawLine(borderLineWidth, deltaY-borderLineWidth, panel.Width-borderLineWidth,deltaY-borderLineWidth, colorLine, 2*borderLineWidth)
			Return 1
		Case "shadow"
			Dim pBground As Panel
			pBground.Initialize("")
			pBground.Background = panel.Background
			rect.Initialize(panel.Width-shadowWidth,0,panel.Width,panel.Height)
			canv.DrawRect(rect,Colors.ARGB(127,0,0,0),True,1dip)
			rect.Initialize(shadowWidth,panel.height-shadowWidth,panel.Width-shadowWidth,panel.Height)
			canv.DrawRect(rect,Colors.ARGB(127,0,0,0),True,1dip)
			rect.Initialize(panel.Width-shadowWidth,0,panel.Width,shadowWidth)
			canv.DrawRect(rect,Colors.Transparent,True,1dip)
			rect.Initialize(0,panel.height-shadowWidth,shadowWidth,panel.Height)
			canv.DrawRect(rect,Colors.Transparent,True,1dip)
			Return 2
	End Select
End Sub
Sub resetDefaults(d As String)	' useful for reset form with data foe example from Db
	Dim f() As String = Regex.Split(",",quoteMask(d))
	For ir=0 To f.Length - 1
		Dim fromTo() As String = Regex.split("\s*" & keyValueSeparator,f(ir) & keyValueSeparator)
		If fromTo.Length = 2 Then Defaults.Put(fromTo(0),deMask(fromTo(1)))
	Next
	setDefaults(0)
End Sub
Sub setDefaults(reset As Int)	' 0 for reset all, > 0 is reset on tab, -1 from data (is the case of sections)
	For Each k As String In Defaults.Keys
		Dim wdgType As String = fh_FieldsType.GetDefault(k,"")
		If wdgType = "" Then 
			ToastMessageShow("This field " & k & " doesn't exits",False)
			Return	' my be an inexistent field
		End If
		Dim a() As Object = allButtons.getDefault(k,Array As Object(0,0,0))
		If Not("*B*IB*TIMER*TB*TITLE*TAB*I*H*C*".Contains("*" & wdgType & "*")) Then	' there is no label
			Dim wdgl As Label = getFromViewMap(k,2)
			wdgl.TextColor = mapFontLabel.Get("TextColor")
			a(2) = getFromViewMap(k,4)	' tab number
		End If
		If reset = -1 Then
			If fh_Data.ContainsKey(k) Then
				setValue(k,fh_Data.Get(k))	' data from another section
			Else
				If fh_FieldsType.ContainsKey(k) Then  setValue(k,Defaults.Get(k))
			End If
		else If reset = a(2) Then		' reset = 0 Or a(2) = currentTab
			If fh_FieldsType.ContainsKey(k) Then setValue(k,Defaults.Get(k))	' this manage sections
		End If
	Next
End Sub
Sub extractRandom(xx() As String) As String() 	' xx(0) name, xx(1) defaults
	Dim retxx(2) As String = Array As String(xx(0),"")
	If Not(Elem.ContainsKey(xx(0))) Then
		MsgboxAsync(xx(0) & " is not a wiew","")
		Return retxx
	End If
	If xx.Length <> 2 Then 
		Dim Fields() As String = Elem.GetDefault(xx(0),"")	' if no defaults, take item list
		retxx(1) = Fields(5)
	Else
		retxx(1) = xx(1)
	End If
	Dim Match As Matcher
	Match = Regex.Matcher(re, retxx(1))
	If Match.Find Then
		retxx(1) =  Rnd(Match.Group(1),Match.Group(2) + 1)
	Else
		If retxx(1) <> "" Then
			Dim rString() As String = Regex.Split("\|",Regex.Replace("\|.*?:","|" & retxx(1),"|"))
			Dim rndx As Int = 0
			If rString.Length > 1 Then rndx = Rnd(1,rString.Length)
			retxx(1) = rString(rndx)
		End If
	End If
	Return retxx
End Sub
Private Sub getHeight(rows As Int) As Int	
	If rows < 2 Then Return widgetHeight
	Return baseHeight + 0.8 * charHeight*Max(1,rows) ' ex 5/10/19
End Sub
Sub mask(data As String) As String	' mask comma AND semicolon
	Dim s As String = data.Replace(",","#44")
	Return s.Replace(";","#59")
End Sub
Sub deMask(text As String)	As String
	If text.StartsWith("@") Then text = fhSubstMap.GetDefault(text,text)
	Dim Match As Matcher = Regex.Matcher(reDeMask, text)
	Do While Match.Find
		If (Match.Match).ToUpperCase.CharAt(1) = "X" Then
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(2),16)))
		Else
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(1),10)))
		End If
	Loop
	Return replace(text)
End Sub
Sub Left(s As String,l As Int) As String
	If l < s.Length Then Return s.SubString2(0,l)
	Return s
End Sub
Sub Right(s As String,l As Int) As String
	If l < s.Length Then Return s.SubString(s.Length-l)
	Return s
End Sub
Private Sub insertlistDir(dir As String) As List
	Dim lst As List
	lst.Initialize
	Dim lst2 As List = File.ListFiles(dir)
	If lst2.IsInitialized Then
		If File.IsDirectory(dir,"") Then		
			lst.AddAll(lst2)
			lst.SortCaseInsensitive(True)
			If dir.indexOf2("/",1) > -1 Then lst.InsertAt(0,"..")
		End If
	End If
	Return lst
End Sub
Sub setComboValues(Name As String,values As String) As Int
	Select viewType(Name)
		Case "CMB"
			Dim cmb As Spinner = getFromViewMap(Name,0)
		Case "CMT","CMX"
			Dim cmb As Spinner = getFromViewMap(Name,3)
	End Select
	cmb.Clear
	cmb.addall(splitKeyValue(Name,values))
	Return cmb.Size
End Sub
Sub splitKeyValue(name As String,data As String) As List ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt(),key,value As String,k As Int 
	Dim lst As List
	lst.Initialize
	If data.Length > 0 Then
		dt = Regex.Split("\|", data)
		For j = 0 To dt.Length - 1
			If dt(j).IndexOf(keyValueSeparator) < 0 Then dt(j)=dt(j) & keyValueSeparator & dt(j)
			k = dt(j).IndexOf(keyValueSeparator)
			key = dt(j).SubString2(0,k)
			value = dt(j).SubString(k+1)
			mapValues.Put(name & value,key)
			If value <> key Then mapValues.Put(name & key,value)	' 3 may 2019
			lst.add(value)
		Next
	End If
	Return lst
End Sub
Private Sub RadioButton_CheckedChange(chk As Boolean)
	rdbCommon(Sender)
End Sub
private Sub RDBbuttons_Click
	Dim img As Button = Sender
	Dim rdb As RadioButton = img.tag
	rdb.Checked = True
End Sub
Private Sub rdbCommon (rdb As RadioButton)
	Dim wdgl As Label = getFromViewMap(rdb.Tag,2)
	wdgl.TextColor = mapFontLabel.Get("TextColor")	' in case of required
	Dim a() As Object = widgetRef.get(rdb.Tag)
	a(3) = rdb
	widgetRef.Put(rdb.tag,a)
	rdb.Checked = True
	handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
End Sub
Private Sub TButtons_Click		' *** toggle buttons
	Dim btnToggle As Button = Sender
	Dim lst As List = togglesMap.Get(btnToggle.tag)
	setValue(btnToggle.tag,lst.Get((lst.IndexOf(btnToggle.text)+1) Mod lst.Size))
	handleEvents(Array As Object (btnToggle.tag,"CLICK",btnToggle, mapValues.get(btnToggle.tag & btnToggle.text)))
End Sub
Private Sub Buttons_Click		' *** exit routin
	Dim btnView As View = Sender
	Dim btnTag As String = btnView.Tag
	handleEvents(Array As Object (btnView.tag,"CLICK",btnView))
	If btnTag = "Reset" Then
		setDefaults(IIf(nTabs > 0,currentTab,0))
		handleEvents(Array As Object ("fh_reset","Reset"))
	Else If  btnTag = "Cancel" Then
		handleEvents(Array As Object ("fh_cancel","End"))
		fh_Data.Put("fh_button", btnTag)
		fh_panel.RemoveView
		fh_groundPanel.RemoveView
		fh_isRunning = False
		fh_Data = CreateMap("fh_button":"Cancel")
		For Each t As Timer In timersMap.Keys
			t.Enabled = False
		Next
		If fh_returnSub = "" Then Return
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
	Else
		Dim k() As Object = allButtons.Get(btnTag)
		If k(1) <> "" Then	' there is a callback
			fh_CallSub(btnTag,k(1))
			Return
		End If
		If CheckErrors(btnTag) Then
			If fh_yesToExit Then				
				If btnTag = "fh_Forward" Or btnTag = "fh_Back" Then
					Section = IIf(btnTag = "fh_Forward",Section + 1,Section - 1)
					Dim condition As Boolean = False
					Do While Not(condition)
						condition = True
						Dim conditions() As String = Regex.Split(",",Sections(Section,2))					
						For i = 0 To conditions.Length - 1
							Matcher1 = Regex.Matcher("(.+?)\s*(=|<=|>=|<>|>|<)\s*(.*)",conditions(i))
							If Not(Matcher1.Find) Then Continue
							Dim fieldName As String = Matcher1.Group(1)
							If Not(compare(numericTypes.GetDefault(fh_FieldsType.GetDefault(fieldName,False),False),fh_Data.GetDefault(fieldName,""),Matcher1.Group(2),deMask(Matcher1.Group(3)))) Then
								condition = False
							End If
						Next
						If condition Then
							fh_panel.RemoveView
							fh_groundPanel.RemoveView
							CallSubDelayed3("","fgSection", Sections(Section,0),fh_Data)
						Else
							MsgboxAsync("Session " & Sections(Section,1) & " not activated for condition '" & Sections(Section,2) & "'","")
							Section = (Section + IIf(btnTag = "fh_Forward",1, - 1)) Mod Sections.Length
						End If
					Loop
				Else				
					For Each key In hiddensMap.Keys	' hidden data?
						fh_Data.Put(key,hiddensMap.Get(key))
					Next
					handleEvents(Array As Object ("fh_end","End"))
					fh_panel.RemoveView
					fh_groundPanel.RemoveView
					For Each t As Timer In timersMap.Keys
						t.Enabled = False
					Next
					fh_isRunning = False
					If fh_returnSub = "" Then Return
					CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
					fh_yesToExit = True
				End If							
			Else
				fh_yesToExit = True
			End If
		End If
	End If
End Sub
Private Sub CheckErrors(btnTag As String)	As Boolean	' for button end spinner aka button list
	Private signal As String = ""
	For Each k As String In widgetRef.Keys
		Dim vType As String = viewType(k)
		field = Elem.Get(k)
		If "B*C*TAB*TITLE*I*".Contains(vType & "*") Then Continue	' not fields
		Dim wdgtValue As String = valueOf(k)
		If checks.ContainsKey(k) Then
			Dim s As String = CheckField(k,wdgtValue)
			If s <> "" Then signal = signal & "," & s
		End If
		fh_Data.Put(k,wdgtValue)	' set wiew value
	Next
	If signal <> "" Then 
		ToastMessageShow(signal.SubString(1),True)
		Return False
	End If
	fh_Data.Put("fh_button",btnTag)
	Return True
End Sub
Sub getLabelHandle(Name As String) As Label
	Return getFromViewMap(Name,2)
End Sub
Sub CheckField(name As String, wdgtValue As String) As String
	Dim wdgl As Label = getFromViewMap(name,2)
	wdgl.TextColor = mapFontLabel.Get("TextColor")
	If checks.ContainsKey(name) Then
		Private check As Map = checks.Get(name)
		For Each k As String In check.Keys
			Dim strCheck(3) As String =  check.Get(k)
			Dim operand As String = strCheck(1)
			Dim operator As String = strCheck(0)
			If operator <> "is" Then
				If widgetRef.ContainsKey(operand) Then operand = valueOf(operand)	' compare with field
				If Not(compare(numericTypes.GetDefault(viewType(name),False),valueOf(name),operator,operand)) Then
					Return setError(wdgl,strCheck(2))
				End If
			Else
				If operand.ToLowerCase() = "required" Then
					If wdgtValue = "" Then Return setError(wdgl,strCheck(2))
				Else If operand.ToLowerCase() = "date" Then
					Try
						DateTime.DateParse(wdgtValue)
					Catch
						Return setError(wdgl, LastException)
					End Try
				else If operand.ToLowerCase() = "mail" Then
					If Not(Regex.IsMatch(reMail,wdgtValue)) Then
						Return setError(wdgl,strCheck(2))
					End If
				Else 		' my be a regular expression
					If wdgtValue <> "" And Not(Regex.IsMatch(deMask(operand),wdgtValue)) Then Return setError(wdgl,strCheck(2))
				End If
			End If
		Next
	End If
	Return ""
End Sub
Private Sub compare(Numeric As Boolean,wdgtValue As String, operator As String, operand As String) As Boolean
	Dim cfr As Int = 1	' means equal
	If Numeric Then		' numeric field
		If wdgtValue = "" Then Return True			' no data - no compare
		If Not(IsNumber(operand)) Then Return True	' no data - no compare
		If wdgtValue > operand Then cfr = 2
		If wdgtValue < operand Then cfr = 4
	Else
		Dim cfr As Int = wdgtValue.CompareTo(operand)
		If cfr > 0 Then cfr = 2
		If cfr < 0 Then cfr = 4
		If cfr = 0 Then cfr = 1
	End If
'	Log("Numeric " & Numeric & TAB & wdgtValue & TAB & operator & TAB & operand)
'	Log(cfr & TAB & comparator.Get(operator))
'	Log(Not(Bit.And(cfr,comparator.Get(operator)) = 0))
	If Bit.And(cfr,comparator.Get(operator)) = 0 Then Return False
	Return True
End Sub
Private Sub setError(l As Label,s As String) As String
	l.TextColor = Colors.Red
	Return l.tag & ": " & s
End Sub
Private Sub handleEvents(parms() As Object) As Boolean
	If fh_handleSub <> "" Then CallSub2(fh_module,fh_handleSub,parms)
End Sub
Private Sub Combos_ItemClick(Position As Int, Value As Object)
	Dim cb As Spinner = Sender
	Dim wdgl As Label = getFromViewMap(cb.Tag,2)
	wdgl.TextColor = mapFontLabel.Get("TextColor")	' in case of required
	Dim typeWidget As String = viewType(cb.Tag)
	handleEvents(Array As Object (cb.Tag,"CLICK",cb,mapValues.GetDefault(cb.Tag & cb.SelectedItem,"")))
	If typeWidget = "F" Then
		Dim dir As String = getFromViewMap(cb.Tag,3)	' folder
		Dim lblFile As Label = tipsMap.get(cb.Tag)
		If Value = ".." Then
			Dim fileInfo As Map = pathinfo(dir)
			dir = fileInfo.Get("dirname")
			Value = ""
		End If
		If Not(dir.EndsWith("/")) And Value <> "" Then dir = dir & "/"
		If File.IsDirectory(dir, Value) = True Then
			If Not(File.ListFiles(dir & Value).IsInitialized) Then
				ToastMessageShow(dir & Value & " folder not accessible",False)
			Else
				cb.clear
				cb.AddAll(insertlistDir(dir & Value))
				setInMap(cb.Tag,3,dir & Value)
				cb.SelectedIndex = 0
				lblFile.Text = dir & Value
			End If
		End If
	Else If typeWidget = "CMX" Then
		Dim txt As EditText = IIf(widgetRef.ContainsKey(cb.tag),getFromViewMap(cb.tag,0),-1)
		If Not(txt.Text.Contains(Value)) Then
			If txt.Text <> ""  Then  txt.Text =  txt.Text & Chr(10)
			txt.Text = txt.Text & Value
		End If
	Else If typeWidget = "CMT" Then
		setValue(cb.Tag,Value)
	Else If typeWidget = "CMB" And typeForm = "C" Then		' only one spinner
		handleEvents(Array As Object ("fh_end","End"))
		fh_Data.Put(field(1),valueOf(field(1)))
		fh_panel.RemoveView
		fh_groundPanel.removeView
		fh_isRunning = False
		If fh_returnSub = "" Then Return
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
	End If
End Sub
Private Sub txt_EnterPressed
	Dim txt As EditText = Sender
	handleEvents(Array As Object (txt.tag,"ENTER",txt,focusTxt.text))
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
	focusTxt = Sender
	handleEvents(Array As Object (focusTxt.tag,IIf(HasFocus,"FOCUS","LFOCUS"),Sender,focusTxt.text))
	If HasFocus Then
		If tipsMap.ContainsKey(focusTxt.Tag) Then ToastMessageShow(tipsMap.get(focusTxt.Tag),False)
		If viewType(focusTxt.Tag) = "T" Then startVoiceRec
	Else
		Dim signal As String = CheckField(focusTxt.Tag,focusTxt.Text)	' checks data
		If signal <> "" Then
			ToastMessageShow(signal,True)
		End If		
	End If
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	If viewType(ckb.Tag) = "CKL" Then
		Dim name As String = getFromViewMap(ckb.Tag,3)	' name of chek list
		setValue(name,valueOf(name)+IIf(Checked,1,-1))
	End If
	handleEvents(Array As Object (ckb.tag,"CKB",ckb,IIf(Checked,"1","0")))
End Sub
Private Sub Slide_ValueChanged (Value As Int, UserChanged As Boolean)
	Dim slideValue As Double,dec As Int,seekLabel As Label
	Dim sld As SeekBar = Sender
	Dim wdgl As Label = getFromViewMap(sld.Tag,2)
	wdgl.TextColor = mapFontLabel.Get("TextColor")	' in case of required
	seekLabel = getFromViewMap(sld.Tag,3)
	If getFromViewMap(sld.Tag,1) = "QS" Then
		Private listQs As List = Limits.Get(sld.Tag)
		seekLabel.text = listQs.Get(Value)
		slideValue = Value
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,seekLabel.Text,getFromViewMap(sld.tag,3)))
	Else
		If UserChanged Then
			slideValue = Limits.get(sld.Tag & "Min") + Value * (Limits.get(sld.Tag & "Delta"))/100
			dec = Floor(Logarithm(Limits.get(sld.Tag & "Delta"),10))	' delta
			seekLabel.text = NumberFormat(slideValue,1,0)
			If dec < 3 Then seekLabel.text = NumberFormat(slideValue,1,-dec+2)
		End If
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,seekLabel.Text,getFromViewMap(sld.tag,3)))
	End If
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
    	k = msk.IndexOf(mtc.Match)
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0)) 
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub TypeOf(obj As Object) As String
Dim t() As String = Regex.Split("\.",GetType(obj))
Return t(t.Length - 1)
End Sub
Private Sub fillString(n As Int) As String
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then
		aWdg(pos) = val
	End If
	widgetRef.Put(fld,aWdg)
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":"","extension":"","filename":"","basename":"")
	Dim k As Int = dir.LastIndexOf("/")
	If k >= 0 Then	fInfo.Put("dirname",Left(dir,k))
	Dim fl As String = dir.SubString(k+1)
	fInfo.Put("basename",fl)
	k = fl.LastIndexOf(".")
	fInfo.Put("filename",fl)
	If k >= 0 Then 
		fInfo.Put("filename",Left(fl,k))
		fInfo.Put("extension",fl.SubString(k+1))
	End If
	Return fInfo
End Sub
Sub startVoiceRec()
'	VR.Listen 'calls the voice recognition external activity
End Sub
Sub addCheck(condition As String,signal As String)
	Matcher1 = Regex.Matcher2("(.+?)\s*(=|<=|>=|<>|>|<|is)\s*(.*)",Regex.CASE_INSENSITIVE,condition)
	If Matcher1.Find Then
		Dim widgetName As String = Matcher1.Group(1)
		Dim operator As String = Matcher1.Group(2).TolowerCase
		Dim operand As String = Matcher1.Group(3)
		Private a As Map = CreateMap()
'		a.Initialize
		If checks.ContainsKey(widgetName) Then a = checks.Get(widgetName)
		a.Put(operator & operand,Array As String(operator,operand,signal))
		checks.Put(widgetName,a)
	End If
End Sub
Sub VR_Result (Success As Boolean, Texts As List)
	If Success = True Then
		Dim a() As Object = Array As Object(focusTxt.tag,"VREND",focusTxt,Texts.get(0))
		handleEvents(a)
		focusTxt.text = IIf(focusTxt.text = "",  a(3), focusTxt.text & Chr(13) & Chr(10) &  a(3))
		startVoiceRec
	End If
End Sub
Sub enable(Name As String)
	SetWidget(Name,"Enable")
End Sub
Sub disable(Name As String)
	SetWidget(Name,"Disable")
End Sub
Private Sub SetWidget(Name As String, option As String)
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))	
	If aWdg.Length = 1 Then 
		If viewType(Name) <> "B" Then  Return	' key exist?
		aWdg(0) = handleButtonsMap.get(Name)
	End If
	If TypeOf(aWdg(0)) = "Timer" Then
		Dim t As Timer = aWdg(0)
		t.Enabled = IIf(option.ToLowerCase = "enable",True,False)
	Else
		Dim v As View = aWdg(0)
		v.Enabled = IIf(option.ToLowerCase = "enable",True,False)
	End If
End Sub
Sub getHandle(Name As String) As Object
	If fh_FieldsType.GetDefault(Name,"") = "B" Then Return handleButtonsMap.Get(Name)
	Return getFromViewMap(Name,0)
End Sub
Sub getFromViewMap(Name As String,pos As Int) As Object	' Id, widgetType, label, extraField, tab
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(Null))
	If pos < aWdg.Length Then Return aWdg(pos)
	Return Null
End Sub
Sub viewType(Name As String) As String
	Return fh_FieldsType.get(Name)
End Sub
Sub valueOf(Name As String) As Object
	If Not(fh_isRunning) Then	' in case of form closed
		If Name.StartsWith("fh_") Then Return mapValues.GetDefault(Name.SubString(3) & valueOf(Name.SubString(3)),"")
		Return fh_Data.GetDefault(Name,"")
	End If
	If Name.StartsWith("fh_") Then Return mapValues.GetDefault(Name.SubString(3) & valueOf(Name.SubString(3)),"")
	Dim a() As Object = widgetRef.GetDefault(Name,Array(0,0,0))
	Dim wType As String = viewType(Name)
	Select wType		' widget type
		Case "TAB","TITLE"
		Case "CMB","F"
			Dim cmb As Spinner = a(0)
			If wType = "CMB" Then Return mapValues.GetDefault(Name & cmb.SelectedItem,"")
			Return a(3) & "/" & IIf(cmb.SelectedItem = "..","",cmb.SelectedItem)
		Case "CKB","CKL"
			Dim chk As CheckBox = a(0)
			Return (IIf(chk.Checked,"1","0"))
		Case "S","QS"		' SeekBar
			Dim seekLabel As Label = a(3)
			If wType = "QS" Then Return mapValues.get(Name & seekLabel.text)
			If seekLabel.text <> "" Then Return seekLabel.text
			Dim seek As SeekBar = a(0)
			If seek.Value > 0 Then
				Return Limits.get(Name & "Min") + seek.Value * (Limits.get(Name & "Delta"))/100				
			End If
		Case "U","UN","C","IB"		' Unmodifiable
			Dim uLbl As Label = a(0)
			Return uLbl.text
		Case "R"		' RadioButton
			If a(3) = Null Then Return ""
			Dim rdb As RadioButton = a(3)
			Return mapValues.get(Name & rdb.text)
		Case "TB"
			Dim btnToggle As Button = a(0)
			Return mapValues.get(Name & btnToggle.text)
		Case "H"
			Return hiddensMap.Get(Name)
		Case "TIMER"
			Dim t As Timer =a(0)
			Return t.Interval
		Case Else 		' text Views also CMT combo text
			Dim wdgT As EditText = a(0)
			If wType = "CMT" Then Return mapValues.GetDefault(Name & wdgT.text,wdgT.text)
			Return wdgT.text
	End Select
	Return ""
End Sub
Sub implode(sep As String,obj As List) As String
	Return implodeFrom(sep,obj,0,obj.Size)
End Sub
Sub implodeFrom(sep As String, obj As List, From As Int, At As Int) As String
	Dim implStr As String = ""
	For j = obj.size -1 To From Step -1	' delete last empty items 
		If obj.Get(j) <> "" Then Exit
	Next
	For i = From To Min(At,j)
	     implStr =  implStr & sep & obj.Get(i)
	Next
	If implStr.Length > 0 Then Return implStr.SubString(1)
	Return ""
End Sub
Sub setValue(Name As String,Value As Object)
	Dim wdg As Object = IIf(fh_FieldsType.ContainsKey(Name),getFromViewMap(Name,0),Null)
	Select viewType(Name)
		Case "CMB"
			Dim cmb As Spinner = wdg
			cmb.SelectedIndex = cmb.IndexOf(Value)
			If cmb.SelectedIndex = -1 Then cmb.SelectedIndex = cmb.IndexOf(mapValues.GetDefault(Name & Value,""))
		Case "CMT","CMX"
			Dim cmb As Spinner = getFromViewMap(Name,3)
			Dim txt As EditText = wdg
			txt.Text = Value	
			cmb.SelectedIndex = IIf(cmb.IndexOf(Value) > - 1,cmb.IndexOf(Value),0)		
		Case "F","
			Dim cmb As Spinner = wdg
			Dim fileInfo As Map = pathinfo(Value)
			Dim dir As String = fileInfo.Get("dirname")
			Dim fl As String = fileInfo.Get("basename")
			If dir = "" Then dir = File.DirRootExternal
			Dim lblFile As Label = tipsMap.Get(Name)
			lblFile.Text = dir
			cmb.Clear
			cmb.addall(insertlistDir(dir))
			setInMap(Name,3,dir)
			cmb.SelectedIndex = -1
			cmb.SelectedIndex = cmb.IndexOf(fl)
		Case "S"
			Dim sld As SeekBar = wdg
			Dim seekLabel As Label = getFromViewMap(sld.Tag,3)
			If IsNumber(Value) Then
				sld.Value = (Value - Limits.get(sld.Tag & "Min"))*100/(Limits.get(sld.Tag & "Max") - Limits.get(sld.Tag & "Min"))
				seekLabel.Text = Value
			Else
				sld.Value = 0	' Limits.Get(Name & "Min")	' set un.
				seekLabel.Text = ""
			End If
		Case "QS"
			Dim sld As SeekBar = wdg
			Private listQs As List = Limits.Get(Name)
			listQs.IndexOf(Value)
			sld.Value = listQs.IndexOf(Value)
		Case "T","N","NF","NS","P","TIME","DATE","C"
			Dim txt As EditText = wdg
			field = Elem.Get(Name)
			If field(0) = "DATE" And Left(Value,3).ToLowerCase = "now" Then
				addCheck(field(1) & " is Date","Incorrect date")
				If field(5) <> "" Then
					DateTime.DateFormat = field(5)
					addCheck(field(1) & " is ^" & field(5).Replace("d","\d").Replace("M","\d").Replace("y","\d") & "$","Incorrect date")
				End If
				txt.text = DateTime.Date(DateTime.Now)
			Else if field(0) = "TIME" And Left(Value,3).ToLowerCase = "now" Then
				txt.text = DateTime.Time(DateTime.Now)
			Else
				txt.text = Value
			End If
		Case "CKB"
			Dim ckb As CheckBox = wdg
			ckb.Checked = IIf(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "CKL"
			Dim ckb As CheckBox = wdg
			Dim wName As String = getFromViewMap(ckb.Tag,3)	' name of chek list
			Dim  countCheck As Int = valueOf(wName)
			If ckb.Checked Then ckb.Checked = False
			setValue(wName,countCheck)
			ckb.Checked = IIf(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "U","UN"
			Dim uLbl As Label = wdg
			uLbl.text = Value
			If viewType(Name) = "C" Then uLbl.Width = canvForMeasure.MeasureStringWidth(Value,Typeface.DEFAULT,12)
		Case "R"
			pnl = getFromViewMap(Name,0)
			Dim v As View
			setInMap(Name,3,Null)
			For i = 0 To pnl.NumberOfViews -1
				v = pnl.GetView(i)
				If TypeOf(v) = "RadioButton" Then
					Dim rdb As RadioButton = pnl.GetView(i)
					rdb.Checked = False
					If rdb.text = Value Or rdb.text = mapValues.GetDefault(Name & Value,"") Then 
						rdb.Checked = True
						setInMap(Name,3,rdb)
					End If
				End If
			Next
		Case "H"
			hiddensMap.put(Name,Value)
		Case "B"
			Dim btnx As Button = handleButtonsMap.Get(Name)
			btnx.Enabled = IIf(Left(Value,3).ToLowerCase = "dis",False,True)
		Case "TB"
			Dim btnToggle As Button = wdg
			Dim lst As List = togglesMap.Get(Name)
			btnToggle.TextColor = Colors.Black
			If lst.IndexOf(Value) = -1 Then 
				btnToggle.text = lst.Get(0)
			Else
				btnToggle.text = lst.Get(lst.indexOf(Value))
			End If
			If File.Exists(File.DirAssets,btnToggle.text) Then ' grafic button
				Dim x As Bitmap
				x.Initialize(File.DirAssets,btnToggle.text)
				btnToggle.SetBackgroundImage(x)
				btnToggle.TextColor = Colors.argb(0,0,0,0)	' text transparent
			End If
		Case "TIMER"
			Dim t As Timer = wdg
			t.Enabled = IIf(Left(Value,3).ToLowerCase = "enable",True,False)
	End Select
	handleEvents(Array As Object (Name,"SETVALUE",wdg,Value))
End Sub
Sub decodeColor(C As String) As Int
	Dim Match As Matcher = Regex.Matcher(reHexaDecimal, C)
	If Not(Match.Find) Then
		Return colorsMap.GetDefault(C.ToLowerCase,-12566464) 	' FF404040  grey (-16 777 216 opaque black)‬
	Else
		C = (Left("FF000000",8-C.Length) & C)		' eight exadecimals digit
		If (C.SubString2(0,1)).compareto("7") > 0 Then Return - Power(2,31) + Bit.ParseInt("01234567".CharAt(Bit.ParseInt(C.SubString2(0,1),16)-8) & C.SubString(1),16)
		Return Bit.ParseInt(C,16)
	End If
End Sub
Sub CreateText(txt As EditText,fld() As String)
	If txt.IsInitialized Then txt.Invalidate
	txt.Initialize("txt")
	txt.Padding = padding	' Array As Int(4dip,5dip,2dip,5dip)
	txt.Gravity = Bit.Or(Gravity.TOP, Gravity.Left)
	backgroundDrawable.Initialize(Colors.ARGB(63,255,255,255), 3dip)
	fhMap_ColorDrawable.Put(fld(1),backgroundDrawable)
	txt.Background = fhMap_ColorDrawable.get(field(1))
	txt.Background = backgroundDrawable
	txt.TextSize = 12
	txt.Tag = fld(1)
	txt.InputType = textAttributes.GetDefault(fld(0),Bit.Or(1,16384))	' 14 April 2019 default capitalize sentences
	If field(3) > charPerRow Then txt.InputType = Bit.Or(txt.InputType,131072)	' multiline 16 April 2019
End Sub
Sub CreateCSLabel(Text As String, selected As Boolean) As CSBuilder
	Dim cs As CSBuilder
	If selected Then Return cs.Initialize.Underline.Color(Colors.white).Append(Text).PopAll
	Return cs.Initialize.Color(Colors.LightGray).Append(Text).PopAll
End Sub
Sub Createlabel(txt As String,Size As Int, event As String) As Label
	Dim lbl As Label
	lbl.Initialize(event)
	lbl.Padding = Array As Int (3dip, 0, 3dip, 0)
	lbl.TextSize = Size
	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	lbl.Text = txt
	Return lbl
End Sub
Sub createTriangle(w As Int, h As Int) As Bitmap
	Private bmp As Bitmap
	bmp.InitializeMutable(w,h)
	Dim cnv As Canvas
	cnv.Initialize2(bmp)
	Dim p As Path
	p.Initialize(5dip, 5dip)
	p.LineTo(w/2, h-5dip)
	p.LineTo(w-5dip, 5dip)
	p.LineTo(5dip,5dip)
	cnv.DrawPath(p, Colors.ARGB(63,0,0,0), True, 1)
	Return bmp
End Sub
Sub createGradient(color As String) As GradientDrawable	
	Dim grad As GradientDrawable
	Dim cols(2) As Int
	If color = "" Then color = "FF404040 FF404040"
	Dim prms() As String = Regex.split("[ ]+",color & " * *")	'force three items (almosT)
	If prms.Length = 3 Then prms(1) = prms(0)
	If prms.Length < 5 Then prms(2) = "TOP_BOTTOM"
	cols(0) = decodeColor(prms(0))
	cols(1) = decodeColor(prms(1))
	grad.Initialize(prms(2),cols)
	Return grad
End Sub
Sub onglets_Click	
	Dim lbl As Label = Sender
	changeOnglet(lbl)
End Sub
Sub changeOnglet(lbl As Label)
	If currentTab <> lbl.tag Then
		fh_panels(currentTab).Visible = False
		lbl.Text = CreateCSLabel(tabAttribs(lbl.tag).caption,True)
		lbl.invalidate
		tabAttribs(currentTab).lbl.Text = CreateCSLabel(tabAttribs(currentTab).caption,False)
		fh_panels(lbl.Tag).Visible = True
		handleEvents(Array As Object ("TAB" & lbl.tag,"OPEN","TAB" & currentTab))
		currentTab = lbl.tag
	End If
	
End Sub
Sub topAfterView(aV As View,v As View)' center after view and possibly reduce
	v.Top = aV.Top+(aV.Height - v.Height)*0.5
	If aV.Left+aV.Width+v.width > wWidth Then	' 23 4 2020
		aV.Width = aV.Width*0.9
		v.Left = v.Left-0.1*aV.Width
		aV.Invalidate
		v.invalidate
	End If
	If TypeOf(aV) = "SeekBar" Then v.Left = v.Left + 25dip
	v.invalidate
End Sub
Sub replace(what As String) As String
	Dim memDateFormat As String = DateTime.DateFormat	' save date format
	DateTime.DateFormat = "ddMMyyyy"
	Dim dt As Long = DateTime.DateParse("01012018")	' because is sunday
	Dim x As String
	Select what.ToLowerCase
		Case "%days"
			DateTime.DateFormat = "EEEE"
			For i= 0 To 6
				x = x  & "|" & DateTime.Date(dt)
				dt = DateTime.Add (dt, 0, 0, 1)
			Next
		Case "%months", "%#months"
			DateTime.DateFormat = "MMMM"
			For i= 1 To 12
				x = x  & "|" & IIf(what.StartsWith("%#"),i & keyValueSeparator,"") & DateTime.Date(dt)
				dt = DateTime.Add (dt, 0, 1, 0)
			Next
	End Select
	DateTime.DateFormat = memDateFormat	' restore date format
	If x.Length = 0 Then Return what	' unchanged
	Return x.SubString(1)
End Sub